import processing.core.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class Line extends PApplet {// ------------------------------------------------------------------------------
// Line - http://www.arkitus.com
// Copyright (C) 2005  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Line.java
// Procedures related to starting up the program and adjusting the settings
// are in this file.
// ------------------------------------------------------------------------------

// Initiate

int num_s;
int num_o;
int num_p;

float fb = 0.6f;             // Bounce constant.
float fk = 0.1f;             // Friction constant.
float fr;                   // Spring constant.
float fg;                   // Gravity constant.
float fd;                   // Damping constant.
float fl;                   // Length constant.

Spring[] Springs;           // Create spring array.
Object[] Objects;           // Create object array.  
HScroller LengthS;          // Create scrollers.
HScroller GravityS;         // Create scrollers.
HScroller SpringS;          // Create scrollers.
HScroller DampingS;         // Create scrollers.

PFont font; 

public void setup()
{
  // Applet Settings
  
  size(800,420);
  framerate(30);
  smooth();
  font = loadFont("Verdana-10.vlw"); 
  textFont(font, 10); 

  // Create Scrollers
  
  LengthS = new HScroller(0.5f, 3, 0.5f, 700, 310, 50);
  GravityS = new HScroller(0, 3, 1, 700, 330, 50);
  SpringS = new HScroller(0.0f, 2, 2, 700, 350, 50);
  DampingS = new HScroller(0.1f, 0.85f, 0.80f, 700, 370, 50);
    
  // Create Objects
  
  num_o = 20;         
  Objects = new Object[num_o];
  
  Objects[0] = new Object(200, 160, 2, 5, 0);
  Objects[1] = new Object(225, 210, 2, 5, 1);
  Objects[2] = new Object(250, 210, 2, 5, 1);
  Objects[3] = new Object(275, 210, 2, 5, 1);
  Objects[4] = new Object(300, 210, 2, 5, 1);
  Objects[5] = new Object(325, 210, 2, 5, 1);
  Objects[6] = new Object(350, 210, 2, 5, 1);
  Objects[7] = new Object(375, 210, 2, 5, 1);
  Objects[8] = new Object(400, 210, 2, 5, 1);
  Objects[9] = new Object(425, 210, 2, 5, 1);
  Objects[10] = new Object(450, 210, 2, 5, 1);
  Objects[11] = new Object(475, 210, 2, 5, 1);
  Objects[12] = new Object(500, 210, 2, 5, 1);
  Objects[13] = new Object(525, 210, 2, 5, 1);
  Objects[14] = new Object(550, 210, 2, 5, 1);
  Objects[15] = new Object(575, 210, 2, 5, 1);
  Objects[16] = new Object(600, 210, 2, 5, 1);
  Objects[17] = new Object(600, 160, 2, 5, 0);
  Objects[18] = new Object(200, 310, 6, 75, 1);
  Objects[19] = new Object(600, 310, 4, 50, 1);
  
  // Create springs
  
  num_s = 17;
  Springs = new Spring[num_s];

  Springs[0] = new Spring(0,1,25);
  Springs[1] = new Spring(1,2,25);
  Springs[2] = new Spring(2,3,25);
  Springs[3] = new Spring(3,4,25);
  Springs[4] = new Spring(4,5,25);
  Springs[5] = new Spring(5,6,25);
  Springs[6] = new Spring(6,7,25);
  Springs[7] = new Spring(7,8,25);
  Springs[8] = new Spring(8,9,25);
  Springs[9] = new Spring(9,10,25);
  Springs[10] = new Spring(10,11,25);
  Springs[11] = new Spring(11,12,25);
  Springs[12] = new Spring(12,13,25);
  Springs[13] = new Spring(13,14,25);
  Springs[14] = new Spring(14,15,25);
  Springs[15] = new Spring(15,16,25);
  Springs[16] = new Spring(16,17,25);  
}

public void draw()
{
  background(255,255,255);
  
  for ( int i=0; i<num_s; i++ )
  {
    Springs[i].pull();
  }
   
  for ( int i=0; i<num_o; i++ )
  {
    Objects[i].drag();
    Objects[i].bounce();
    Objects[i].collide();
    Objects[i].fall();
    Objects[i].move();
  }
  
  for ( int i=0; i<num_s; i++ )
  {
    Springs[i].display();
  }
  
  for ( int i=0; i<num_o; i++ )
  {
    Objects[i].display();
  }
  
  fl = LengthS.update();
  fg = GravityS.update();
  fr = SpringS.update();
  fd = DampingS.update();
  
  fill(100,100,100);
  text("l", 760,312);
  text("g", 760,332);
  text("k", 760,352);
  text("b", 760,372);
  text("Shift + Click", 700, 392);
}

public void mousePressed()
{
  for ( int i=0; i<num_o; i++ )
  {
    Objects[i].checkClick();
  }
  
  LengthS.checkClick();
  GravityS.checkClick();
  SpringS.checkClick();
  DampingS.checkClick();
}

// ------------------------------------------------------------------------------
// Line - http://www.arkitus.com
// Copyright (C) 2005  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// HScroller.java
// The GUI class for the scrollers
// ------------------------------------------------------------------------------

class HScroller
{
  float min;
  float max;
  float def;
  float x;
  float y;
  float xpos;
  float w;
  float scale;
  float value;
  boolean locked;
  
  HScroller( float Min, float Max, float Default, float X, float Y, float W )
  {
    min = Min;
    max = Max;
    x = X;
    y = Y;
    w = W;
    
    scale = ( max - min ) / w;
    def = ( Default - min ) / scale;
    xpos = def;
  }
  
  public float update()
  {
    drag();
    display();
    readValue();
    
    return value;
  }
  
  public void checkClick()
  {
    if ( mousePressed && over() )
    {
      locked = true;
    }
  }
  
  public void drag()
  {
    if ( !mousePressed )
    {
      locked = false;
    }
    if ( locked )
    {
      assignPos(mouseX-x);
    }
  }
  
  public void assignPos( float X )
  {
    xpos = X;
    
    if ( X > w )
    {
      xpos = w;
    }
    if ( X < 0 )
    {
      xpos = 0;
    }
  }
  
  public void readValue()
  {
    value = xpos*scale + min;
  }
  
  public void display()
  {
    noSmooth();
    stroke(200,200,200);
    fill(230,230,230);
    strokeWeight(1);
    line(x,y,x+w,y);
    line(x+def, y-2, x+def, y+2);
    rectMode(CENTER);
    stroke(100,100,100);
    rect(x+xpos, y, 5, 5);
    smooth();
  }
  
  public boolean over() 
  { 
    if( mouseX > x - 10 && mouseX < x + w + 10 && mouseY > y - 10 && mouseY < y + 10 ) 
    { 
      return true; 
    } 
    else
    { 
      return false; 
    } 
  }
}

// ------------------------------------------------------------------------------
// Line - http://www.arkitus.com
// Copyright (C) 2005  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Object.java
// The things that get connected to other objects via strings
// ------------------------------------------------------------------------------

class Object
{
  float x;
  float y;
  float m;
  float r;
  float f;
  float wx;
  float wy;
  float tx;
  float ty;
  float bx;
  float by;
  float vx;
  float vy;
  boolean locked;
  
  Object( float X, float Y, float M, float R, float F )
  {
    x = abs(X);
    y = abs(Y);
    m = M;
    r = R;
    f = F;
    
    tx = ty = vx = vy = 0;
    locked = false;
  }
  
  public void display()
  {
    stroke(0,0,0);
    strokeWeight(3);
    fill(100+f*155, 100+f*155, 100+f*155);
    ellipse(x,y,2*r,2*r);
  }
  
  public void bounce()
  {
    if ( y + vy + r > height-4 )
    {
      y = height - r - 4;
      vx *= fk;
      vy *= -fb;
    }
    if ( y + vy - r < 4 )
    {
      y = r + 4;
      vx *= fk;
      vy *= -fb;
    }
    if ( x + vx + r > width-4 )
    {
      x = width - r - 4;
      vx *= -fb;
      vy *= fk;
    }
    if ( x + vx - r < 4 )
    {
      x = r + 4;
      vx *= -fb;
      vy *= fk;
    }
  }
  
  public void fall()
  {
    wx = 0;
    wy = m*fg;
  }
  
  public void collide()
  {
    for ( int i=0; i<num_o; i++ )
    {
      float X = Objects[i].x;
      float Y = Objects[i].y;
      float R = Objects[i].r;
      float M = Objects[i].m;

      float deltax = X-x;
      float deltay = Y-y;
      float d = sqrt(pow(deltax,2)+pow(deltay,2));
      
      if ( d < r + R + 6 && d > 0 )
      {
        // We add the 6 to compensate for the
        // stroke thickness the balls have
        float dD = r + R + 6 - d;
        float theta = atan2(deltay,deltax);
        
        bx += -dD*cos(theta)*M/(m+M);
        by += -dD*sin(theta)*M/(m+M);
      }
    }
  }

  public void move()
  {
    float fx = tx + wx + bx;
    float fy = ty + wy + by;
    
    bx = by = tx = ty = 0;
    
    float ax = fx/m;
    float ay = fy/m;
    
    vx += f*ax;
    vy += f*ay;
    
    vx *= fd;
    vy *= fd;
       
    x += vx;
    y += vy;
  }
  
  public void checkClick()
  {
    if ( over() )
    {
      locked = true;
      if ( keyPressed )
      {
        if ( keyCode == SHIFT )
        {
          if ( f == 0 ) { f = 1; }
          else if ( f == 1 ) { f = 0; }
        }
      }
    }
  }
   
  public void drag()
  {
    if ( !mousePressed )
    {
      locked = false;
    }
    if ( locked )
    {
      assignPos(mouseX, mouseY);
    }
  }
  
  public void assignPos( float X, float Y )
  {
    x = X;
    y = Y;
    
    tx = ty = wx = wy = vx = vy = 0;
  }
  
  public boolean over() 
  { 
    if( sqrt(pow(mouseX - x,2)+pow(mouseY-y,2)) < r ) 
    { 
      return true; 
    } 
    else
    { 
      return false; 
    } 
  }
}

// ------------------------------------------------------------------------------
// Line - http://www.arkitus.com
// Copyright (C) 2005  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// String.java
// The thing that connects two objects
// ------------------------------------------------------------------------------

class Spring
{
  int o1;
  int o2;
  float l;
  
  Spring( int O1, int O2, float L )
  {
    o1 = O1;
    o2 = O2;
    l = L;
  }
  
  public void pull()
  {
    float x1 = Objects[o1].x;
    float y1 = Objects[o1].y;
    float x2 = Objects[o2].x;
    float y2 = Objects[o2].y;
    
    float deltax = x2 - x1;
    float deltay = y2 - y1;
    
    float d = sqrt(pow(deltax,2)+pow(deltay,2));
    float theta = atan2(deltay, deltax);
    
    float extensionx = (d - l*fl)*cos(theta);
    float extensiony = (d - l*fl)*sin(theta);
    
    Objects[o1].tx += +fr*extensionx/2;
    Objects[o1].ty += +fr*extensiony/2;
    Objects[o2].tx += -fr*extensionx/2;
    Objects[o2].ty += -fr*extensiony/2;
  }
  
  public void display()
  {
    stroke(150,150,150);
    strokeWeight(2);
    line(Objects[o1].x, Objects[o1].y, Objects[o2].x, Objects[o2].y);
  }
}
static public void main(String args[]) {   PApplet.main(new String[] { "Line" });}}